hdu4528 小明系列故事——捉迷藏
Time Limit: 500/200 MS (Java/Others) Memory Limit: 65535/32768 K (Java/Others)
Total Submission(s): 1228 Accepted Submission(s): 322
一天,小明的妈妈带小明兄弟三人去公园玩耍,公园里面树木很多,有很多地方可以藏身, 于是他们决定玩捉迷藏。经过几轮的猜拳后,第一轮是小明来找其他两个人,游戏规则很简单:
只要小明可以在规定的时间内找到他们就算小明获胜,并且被发现的两个人猜拳决定谁在下一轮负责找人;如果在规定的时间内只找到一个人,那么没有被发现的人获胜,被找到的人下一轮负责找人;如果在规定的时间内一个人都没有找到,则小明失败了,下一轮还是他来找人。现在小明想知道,在规定时间内,自己是否可以找到所有的人,现在他想请你来帮忙计算一下。
为了简单起见,把公园看成是n行m列的矩阵,其中’S’表示小明,’D’表示大名,’E’表示二明,’X’表示障碍物,’.’表示通路。这里,我们把发现定义为,可以直接看到对方, 也就是说两个人在同一行或者同一列,并且中间没有障碍物或者没有其他人就可以看到对方。并且假设,大明,二明藏好以后就不会再改变位置,小明每个单位时间可以从当前的位置走到相邻的四个位置之一,并且不会走出公园。
每一组测试数据首先是三个正整数n,m,t,分别表示行数、列数和规定的时间,接下来n行,每行m个上述的字符,并且保证有且只有一个’S’,一个’E’,一个’D’。
[Technical Specification]
T < 200
3 <= n, m <= 100
0 <= t <= 100
接下来一行,如果小明可以在规定时间内找到所有的人,则输出最少需要的时间,否则输出-1。
5 6 3
XXD...
....E.
....X.
....S.
......
5 6 3
XDX...
....E.
......
....S.
......
5 6 8
XXDX..
.XEX..
......
....S.
......
-1
Case 2:
3
Case 3:
-1
这题用的是宽搜,其中有个地方要注意,一个位置走过,下次可能还可以走这个位置,但是要满足下次走的这个位置的状态和这次不同,可以用vis[i][j][num2][num3](num2<2 && num3<2)表示是不是经过这个位置且状态是(num2,num3),num2,num3分别代表(x2,y2),(x3,y3)是不是已经看到过。判断是否看到过,可以先预处理一下,用vis2[i][j]判断在(i,j)点是不是能看到(x2,y2),用vis3[i][j]判断在(i,j)点是不是能看到(x3,y3).
#include<iostream>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<vector>
#include<map>
#include<set>
#include<queue>
#include<stack>
#include<string>
#include<algorithm>
using namespace std;
#define ll long long
#define inf 99999999
#define maxn 106
char gra[maxn][maxn];
int vis[maxn][maxn][2][2],vis2[maxn][maxn],vis3[maxn][maxn];
int q[111111][5];
int n,m,x1,y1,x2,y2,x3,y3,shijian,ans;
int tab[6][2]={0,1,-1,0,0,-1,1,0};
void init()
{
int i,j;
memset(vis3,0,sizeof(vis3));
memset(vis2,0,sizeof(vis2));
for(i=x2-1;i>=1;i--){
if(gra[i][y2]!='X'&& gra[i][y2]!='E'){
vis2[i][y2]=1;
}
else break;
}
for(i=x2+1;i<=n;i++){
if(gra[i][y2]!='X'&& gra[i][y2]!='E'){
vis2[i][y2]=1;
}
else break;
}
for(j=y2-1;j>=1;j--){
if(gra[x2][j]!='X' && gra[x2][j]!='E'){
vis2[x2][j]=1;
}
else break;
}
for(j=y2+1;j<=m;j++){
if(gra[x2][j]!='X'&& gra[x2][j]!='E'){
vis2[x2][j]=1;
}
else break;
}
for(i=x3-1;i>=1;i--){
if(gra[i][y3]!='X'&& gra[i][y3]!='D'){
vis3[i][y3]=1;
}
else break;
}
for(i=x3+1;i<=n;i++){
if(gra[i][y3]!='X'&& gra[i][y3]!='D'){
vis3[i][y3]=1;
}
else break;
}
for(j=y3-1;j>=1;j--){
if(gra[x3][j]!='X'&& gra[x3][j]!='D'){
vis3[x3][j]=1;
}
else break;
}
for(j=y3+1;j<=m;j++){
if(gra[x3][j]!='X'&& gra[x3][j]!='D'){
vis3[x3][j]=1;
}
else break;
}
}
void bfs()
{
int i,j,front,rear,num2,num3;
int x,y,xx,yy,t,tt;
front=rear=0;
q[rear][0]=x1;q[rear][1]=y1;q[rear][2]=0;q[rear][3]=0;q[rear][4]=0;
vis[x1][y1][0][0]=1;
while(front<=rear){
x=q[front][0];y=q[front][1];t=q[front][2];num2=q[front][3];num3=q[front][4];
front++;
if(vis2[x][y])num2=1;
if(vis3[x][y])num3=1;
if(num2==1 && num3==1){
ans=t;break;
}
if(t>=shijian)continue;
for(i=0;i<4;i++){
xx=x+tab[i][0];
yy=y+tab[i][1];
if(xx>=1 && xx<=n && yy>=1 && yy<=m && !vis[xx][yy][num2][num3] && gra[xx][yy]!='X' && gra[xx][yy]!='D' && gra[xx][yy]!='E'){
vis[xx][yy][num2][num3]=1;
rear++;
q[rear][0]=xx;q[rear][1]=yy;q[rear][2]=t+1;q[rear][3]=num2;q[rear][4]=num3;
}
}
}
}
int main()
{
int i,j,T,num1=0;
scanf("%d",&T);
while(T--)
{
scanf("%d%d%d",&n,&m,&shijian);
memset(vis,0,sizeof(vis));
for(i=1;i<=n;i++){
scanf("%s",gra[i]+1);
for(j=1;j<=m;j++){
if(gra[i][j]=='S'){
x1=i;y1=j;
}
else if(gra[i][j]=='D'){
x2=i;y2=j;
}
else if(gra[i][j]=='E'){
x3=i;y3=j;
}
}
}
init();
ans=inf;
bfs();
num1++;
printf("Case %d:\n",num1);
if(ans==inf)printf("-1\n");
else printf("%d\n",ans);
}
return 0;
}
hdu4528 小明系列故事——捉迷藏的更多相关文章
- HDU-4528 小明系列故事——捉迷藏 BFS模拟
题意:链接 分析:每一个D或者是E点往四面延伸,并且赋一个特殊的值,能看到D点的点赋值为1,能看到E点的点赋值为1000,这是因为最多100步,因此最后可以根据除以1000和对1000取模来得出某个状 ...
- hdu4528 小明系列故事——捉迷藏(记录状态的BFS)题解
思路: 一道BFS题,和以前的BFS有点不同,这里的vis数组需要记录每次走时的状态,所以开了3维,只对该状态下的vis修改. 注意坑点:S的位置是可以走的 代码: #include<queue ...
- HDU 4528 BFS 小明系列故事——捉迷藏
原题直通车:HDU 4528 小明系列故事——捉迷藏 分析: 标记时加两种状态就行. 代码: #include<iostream> #include<cstring> #inc ...
- C - 小明系列故事――捉迷藏 HDU - 4528 bfs +状压 旅游-- 最短路+状压
C - 小明系列故事――捉迷藏 HDU - 4528 这个题目看了一下题解,感觉没有很难,应该是可以自己敲出来的,感觉自己好蠢... 这个是一个bfs 用bfs就很好写了,首先可以预处理出大明和二明能 ...
- HDU 4828 小明系列故事——捉迷藏
漂亮妹子点击就送:http://acm.hdu.edu.cn/showproblem.php?pid=4528 Time Limit: 500/200 MS (Java/Others) Memo ...
- HDU 4528 小明系列故事――捉迷藏
广搜. 根据题意,可以知道状态总共有$4*n*m$种.每一个位置四种状态:两个都没有发现:发现$E$没发现$D$:发现$D$没发现$E$:两个都发现. 每次移动的花费都是$1$,队列里面状态的费用是单 ...
- hdu 4542 小明系列故事——未知剩余系
小明系列故事——未知剩余系 题意:操作0表示某数有n个约数,操作1为某数有n个非约数:n <= 47777,若是存在小于2^62的数符合,则输出该数,否则若是不存在输出Illegal,若是大于2 ...
- HDU 4511 小明系列故事——女友的考验 (AC自动机+DP)
小明系列故事——女友的考验 Time Limit: 500/200 MS (Java/Others) Memory Limit: 65535/32768 K (Java/Others)Total ...
- HDUOJ-----4506小明系列故事——师兄帮帮忙
小明系列故事——师兄帮帮忙 Time Limit: 3000/1000 MS (Java/Others) Memory Limit: 65535/32768 K (Java/Others)Tot ...
随机推荐
- kubernets之存活探针
一 存活探针存在的意义 1.1 kubernet通过存活探针(liveness probe)检查容器是否还在运行,可以为pod中的每个容器单独指定存活探针,如果探针执行失败,kubernets会 ...
- MyBatis初级实战之四:druid多数据源
欢迎访问我的GitHub https://github.com/zq2599/blog_demos 内容:所有原创文章分类汇总及配套源码,涉及Java.Docker.Kubernetes.DevOPS ...
- 优化太多的if-else
来源java小当家 第1种方法:提前return,减少else判断 1 // 1.优化前 2 private int handlerPre1(boolean flag) { 3 if(flag){ 4 ...
- [Poi2012]Rendezvous
题目描述 给定一个n个顶点的有向图,每个顶点有且仅有一条出边. 对于顶点i,记它的出边为(i, a[i]). 再给出q组询问,每组询问由两个顶点a.b组成,要求输出满足下面条件的x.y: 从顶点a沿着 ...
- centos7 开放指定端口
centos7 开放指定端口 #开放8080端口 firewall-cmd --zone=public --add-port=8080/tcp --permanent #重载防火墙 firewall- ...
- IE浏览器兼容问题总结
IE浏览器兼容问题总结 引自掘金:https://juejin.cn/post/6844903825854185480 一.标准盒模型和怪异盒模型 浏览器的盒子模型分为两类: 标准的W3C盒子模型. ...
- 微服务网关1-Spring Cloud Gateway简介
一.网关基本概念 1.API网关介绍 API 网关出现的原因是微服务架构的出现,不同的微服务一般会有不同的网络地址,而外部客户端可能需要调用多个服务的接口才能完成一个业务需求,如果让客户端直接与各 ...
- 今天聊点干货—关于CSS样式来源
样式来源 CSS样式共有5个来源,它们分别是\(\color{#FF3030}{浏览器默认样式}\).\(\color{#FF3030}{用户样式}\).\(\color{#FF3030}{链接样式} ...
- IE双击打不开解决办法
方法1 [百度电脑专家]一键修复 建议下载并安装[百度电脑专家],官网:http://zhuanjia.baidu.com .打开[百度电脑专家],在搜索框内输入"IE修复",在搜 ...
- 现有以下关系型数据库中的表(见表4-20表4-21和表4-22),要求将具转换为适合Hbase存储的表并插入数据。
① createTable(String tableName, String[] fields) 创建表,参数tableName为表的名称,字符串数组fields为存储记录各个域名称的数组.要 求当H ...